// TARGET DEFINITIONS
def outputfile = "dummy_case2.sql"
def vamount = 2000; // amount of instrument & baskets
def urange = 2; // max amount of underlyings in basket

// INTERNAL DEFINITIONS
def emissiontype = ["F", "P", "H"];
def origin = ["USA", "EU", "OTHER"];
def instrumenttypes = ["Type A", "Type B", "Type C", "Type D"]
def assets = ["AKTIONS", "INDEXES", "GOLD"];

// PROCESSING
def linesToSave = []
// Prepare Basket
(1..vamount).each { key ->
	linesToSave.add("insert into BASKET (ID, VERSION) values ($key, 0);")
}

// Prepare Underlyings

def underlyingtyp = ["UNITS", "INDEX"];
int uindex = 1;
(1..vamount).each { key ->
	
	def array = (1..urange);
	def randamount = array.get(new Random().nextInt(array.size()));
	
	
	(1..randamount).each { ukey ->
		
		def randassetklasse = assets.get(new Random().nextInt(assets.size()));
		def randunderlyingtyp = underlyingtyp.get(new Random().nextInt(underlyingtyp.size()));
		
		linesToSave.add("insert into UNDERLYINGS (ID, VERSION, WKN, ISIN, DESCRIPTION, CURRENCY, TYP, ASSET, BASKET_ID) " + 
				" values ($uindex, 0, 'U$uindex', 'U000$uindex', 'Test Underlying $uindex', 'EUR', '$randunderlyingtyp', '$randassetklasse', $key);");
		uindex++;
	}	
	
}

// Prepare Instrument

def quanto = [0, 1];
def instrumenttemplate = ["Doublechance", "US Actions", "Turbos"];
(1..vamount).each { key ->
	
	def randemissiontype = emissiontype.get(new Random().nextInt(emissiontype.size()));
	def randorigin = origin.get(new Random().nextInt(origin.size()));
	def randquanto = quanto.get(new Random().nextInt(quanto.size()));
	def randinstrumenttemplate = instrumenttemplate.get(new Random().nextInt(instrumenttemplate.size()));
	def randunstrumenttyp = instrumenttypes.get(new Random().nextInt(instrumenttypes.size()));
	
	linesToSave.add("insert into INSTRUMENTS ( " + 
		"ID, " +
		"VERSION, " +
		"WKN, " +
		"ISIN, " +
		"DESCRIPTION, " +
		"TEMPLATE_NAME, " +
		"DDV, " +
		"WM, " +
		"STOCK, " +
		"KAPITAL, " +
		"NOTE, " +
		"QUANTO, " +
		"CREATOR, " +
		"EMITTOR, " +
		"INSTRUMENTTYP, " +
		"BASKET_ID, " +
		"emissiontype, " +
		"ORIGIN ) " +
		
		"values ( " +
		
		"$key, " + 							// ID
		"0, " + 							// VERSION
		"'DE0$key', " + 					// WKN
		"'DE000$key', " + 					// ISIN
		"'Test Bezeichnung $key', " + 		// DESCRIPTIOn
		"'$randinstrumenttemplate', " + 	// TEMPLATE_NAME
		"'DDV $key', " + 					// DDV
		"'WM $key', " +						// WM
		"'1', " + 							// STOCK
		"'1', " +							// KAPITAL
		"'1', " +							// NOTE
		"$randquanto, " +					// QUANTO
		"1, " +				    			// CREATOR
		"1, " +								// EMITTOR
		"'$randunstrumenttyp', " +			// INSTRUMENTTYP
		"$key, " + 							// BASKET_ID
		"'$randemissiontype'," + 			// emissiontype
		"'$randorigin'); ");				// ORIGIN
	
}

new File(outputfile).with { outFile ->
	outFile.withWriter { out -> 
		linesToSave.each {out.println it}
	}
}
